; PIC12F1822 Configuration Bit Settings
; Assembly source line config statements
#include "p12f1822.inc"
#include "TableMacro.inc"

; CONFIG1
; __config 0x984
    __CONFIG _CONFIG1, _FOSC_INTOSC & _WDTE_OFF & _PWRTE_ON & _MCLRE_OFF & _CP_OFF & _CPD_OFF & _BOREN_OFF & _CLKOUTEN_OFF & _IESO_OFF & _FCMEN_OFF
; CONFIG2
; __config 0x1FFF
    __CONFIG _CONFIG2, _WRT_OFF & _PLLEN_ON & _STVREN_ON & _BORV_LO & _LVP_OFF

EncA	equ	RA4
EncB	equ	RA5
SDI	equ	RA2
SDO	equ	RA0
SCK	equ	RA1
SS	equ	RA3

PORT	equ	INDF0
FLAG	equ	INDF1
	
	
udata_shr
Cnt	res	2
Temp	res	1
SpiTemp	res	2


    org		0x00
    goto	main

    org		0x04
    bcf		INTCON,IOCIF
    movf	PORT,w
    andlw	h'30'
    movwf	Temp
    lslf	Temp
    lslf	Temp
    movf	FLAG,w
    iorwf	Temp,w
    clrf	FLAG
    addwf	PCL,f
    NonCnt	    ;0
    IncCnt	    ;1
    DecCnt	    ;2
    NonCnt	    ;3
    NonCnt	    ;4
    DecCnt	    ;5
    IncCnt	    ;6
    NonCnt	    ;7
    NonCnt	    ;8
    DecCnt	    ;9
    IncCnt	    ;A
    NonCnt	    ;B
    NonCnt	    ;C
    IncCnt	    ;D
    DecCnt	    ;E
    NonCnt	    ;F

main:
    banksel	OSCCON
    movlw	b'01110000'
    movwf	OSCCON
    movlw	0x1f
    movwf	OSCTUNE
    
    banksel	TRISA
    movlw	b'00111110'
    movwf	TRISA
    
    banksel	ANSELA
    clrf	ANSELA
 
    banksel	APFCON
    movlw	b'00000000'
    movwf	APFCON
    
    banksel	SSP1CON1
    movlw	0x34
    movwf	SSP1CON1

    movlw	0x00
    movwf	SSP1CON3
    
    movlw	0x40
    movwf	SSP1STAT

    banksel	OPTION_REG
    bcf		OPTION_REG,7
    
    banksel	WPUA
    movlw	b'00001111'
    movwf	WPUA
    
    banksel	IOCAP
    bsf		IOCAP,EncA
    bsf		IOCAP,EncB
    banksel	IOCAN
    bsf		IOCAN,EncA
    bsf		IOCAN,EncB
    
    banksel	IOCAF
    clrf	IOCAF		;flag clear
    clrf	Cnt + 0h	;cnt cleat
    clrf	Cnt + 1h	;cnt cleat
    
    banksel	IOCAF
    clrf	IOCAF

    movlw	h'0C'
    movwf	FSR0L
    movlw	h'00'
    movwf	FSR0H	;PORTA
    
    movlw	h'93'
    movwf	FSR1L
    movlw	h'03'
    movwf	FSR1H	;IOCAF
    
    banksel	PIR1
    bcf		PIR1,SSP1IF
    bsf		INTCON,IOCIE
    bsf		INTCON,PEIE
    bsf		INTCON,GIE  
    
    banksel	SSP1BUF
loop:
    btfsc	PORT,SS
    bra		$-1
    bcf		INTCON,IOCIE
    movf	Cnt + 0h,w
    movwf	SpiTemp + 0h
    movf	Cnt + 1h,w
    bsf		INTCON,IOCIE
    movwf	SSP1BUF
    btfss	SSP1STAT,BF
    bra		$-1
    movf	SpiTemp + 0h,w
    movwf	SSP1BUF    
    
    btfss	PORT,SS
    bra		$-1
    bra		loop
    
    end


